/*
 * Estensione.java
 *
 * Created on 4 dicembre 2007, 18.37
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package babaoglu;
import java.util.*;
import java.io.*;

import murlen.util.fscript.*;

/**
 * <b>Estensione</b> � l'estensione da applicare al motore FScript.
 * Vedere la documentazione di FScript per i vari metodi etc. etc.
 * @author dario
 */
public class Estensione extends BasicExtension {
    
    /** Creates a new instance of Estensione */
    public Estensione(Gioco g) {
        refGioco = g;
        rnd = new Random();
    }
    
    @Override
    public Object callFunction(String name, ArrayList params)
    throws FSException{
        
        // Qui metto i vari casi
        
        // doveNPC(nomeNPC)
        if (name.equals("doveNPC")) {
            return refGioco.posizioneNPC((String)params.get(0));
        }
        
        // inInventario(nomeOggetto)
        else if (name.equals("inInventario")) {
            Boolean ris = refGioco.playerHaOggetto((String)params.get(0));
            if (ris == true) return (new Integer(0));
            else return (new Integer(1));
        }
        
        // inPM
        else if (name.equals("inPM")) {
            Boolean ris = refGioco.playerHaPietra((String)params.get(0));
            if (ris == true) return (new Integer(0));
            else return (new Integer(1));
        }
        
        
        // dovePlayer
        else if (name.equals("dovePlayer")) {
            return refGioco.posizionePlayer();
        }
        
        // daiOggetto
        else if (name.equals("daiOggetto")) {
            refGioco.daiOggettoPlayer((String)params.get(0));
        }
        
        // daiPM
        else if (name.equals("daiPM")) {
            refGioco.daiPietra((String)params.get(0));
        }
        
        // togliOggetto
        else if (name.equals("togliOggetto")) {
            refGioco.togliOggettoPlayer((String)params.get(0));
        }
        
        // togliPM
        else if (name.equals("togliPM")) {
            refGioco.togliPietra((String)params.get(0));
        }
        
        // random(int limite)
        else if (name.equals("random")) {
            Integer limite = (Integer)params.get(0);
            return rnd.nextInt(limite);
        }
        
        // quanteUscite
        else if (name.equals("quanteUscite")) {
            refGioco.getNumeroUscite((String)params.get(0));
        }
        
        // aperta (int qualeUscita)
        else if (name.equals("aperta")) {
            return refGioco.uscitaAperta((String)params.get(0),
                    (Integer)params.get(1));
        }
        
        // dammi dammiIdLoc (int qualeUscita) 
        else if (name.equals("dammiIdLoc")) {
            return refGioco.direzioneUscita((String)params.get(0),
                    (Integer)params.get(1));
        }
        
        // scrivi
        else if (name.equals("scrivi")) {
            int n;
            String s="";
            for(n=0;n<params.size();n++) {
                s=s+ params.get(n);
            }
            
            refGioco.scrivi(s);
        }
        
        // domanda
        else if (name.equals("domanda")) {
            String testo = (String)params.get(0);
            params.remove(0);
            return refGioco.domanda(testo, params);
        }
        
        // spostaNPC
        else if (name.equals("spostaNPC")) {
            // Devo controllare se l'NPC entra o esce dalla
            // locazione in cui si trova il giocatore
            
            // Caso in cui entra:
            if (refGioco.posizionePlayer().equals((String)params.get(1))) {
                refGioco.scrivi((String)params.get(0) + " entra.");
            }
            
            // Caso in cui esce
            if (refGioco.posizionePlayer().equals(refGioco.getLocazioneNPC((String)params.get(0)))) {
                
                // Devo anche trovare da QUALE uscita esce!
                ArrayList<String> p = refGioco.getUsciteEDirezione(refGioco.posizionePlayer());
                String doveEsce = null;
                for (String z : p) {
                    String[] divi = z.split("[|]");
                    if (((String)params.get(1)).equals(divi[1])) doveEsce = divi[0];
                }
                
                if (doveEsce != null) {
                    refGioco.scrivi((String)params.get(0) + " esce a " + doveEsce + ".");
                }
                else {
                    refGioco.scrivi((String)params.get(0) + " esce");
                      
                }
                
            }
            
            // Ora sposto effettivamente il Player
            refGioco.spostaNPC((String)params.get(0),
                    (String)params.get(1));
        }
        
        // spostaPlayer
        else if (name.equals("spostaPlayer")) {
            refGioco.spostaPlayer((String)params.get(0));
        }
        
        // svuotaInventario
        else if (name.equals("svuotaInventario")) {
            refGioco.svuotaInventario();
        }
        
        // apri
        else if (name.equals("apri")) {
            refGioco.apriUscita((String)params.get(0),
                    (String)params.get(1));
        }
        
        // chiudi
        else if (name.equals("chiudi")) {
            refGioco.chiudiUscita((String)params.get(0),
                    (String)params.get(1));
        }
        
        // visibile
        else if (name.equals("visibile")) {
            refGioco.rendiVisibile((String)params.get(0),
                    (String)params.get(1));
        }
        
        // invisibile
        else if (name.equals("invisibile")) {
            refGioco.rendiInvisibile((String)params.get(0),
                    (String)params.get(1));
        }
        return null;
    }
    
    private Gioco refGioco;
    private Random rnd;
   
}
