/*
 * PietraMiliare.java
 *
 * Created on 28 novembre 2007, 21.40
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package babaoglu;

/**
 * La Pietra Miliare rappresenta un passo nel progresso del gioco.
 * @author dario
 */
public class PietraMiliare {
    
    /**
     * Creates a new instance of PietraMiliare
     * @param n Il nome della Pietra Miliare
     * @param e La descrizione dell'evento che la Pietra Miliare registra.<br>
     * è opzionale.
     */
    public PietraMiliare(String n, String e) {
        nome = n;
        evento = e;
    }
    
    /**
     * Restituisce il nome della Pietra Miliare
     * @return Il nome della pietra miliare
     */
    public String getNome() {
        return nome;
    }
    
    /**
     * Restituisce la String dell'evento relativo a questa Pietra Miliare
     * @return La String dell'evento
     */
    public String getEvento() {
        return evento;
    }
    
    private String nome;
    private String evento;
}
