package babaoglu;

import java.io.IOException;
import java.util.ArrayList;
import java.util.concurrent.locks.Lock;
import java.util.logging.Level;
import java.util.logging.Logger;
import murlen.util.fscript.FSException;

class Tempo implements Runnable {
    
    Gioco outer;

    @Override
    public void run() {
        while (!outer.finito) {
            try {
                for (String chi : outer.listaNPC.keySet()) {
//                    outer.scriviDBG("Adesso scomodo " + chi);
                    Lock l = outer.listaNPC.get(chi).getLock();
                    if (l.tryLock()) {
//                        outer.scriviDBG("Ho lockato " + chi);
                        try {
                            ArrayList parametri = new ArrayList();
                            parametri.add("normale");
                            parametri.add("");

                            outer.interprete.callScriptFunction(chi + "_func", parametri);
                            l.unlock();
//                            outer.scriviDBG("Ho unlockato " + chi);
                        } catch (IOException ex) {
                            Logger.getLogger(Gioco.class.getName()).log(Level.SEVERE, null, ex);
                        } catch (FSException ex) {
                            Logger.getLogger(Gioco.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                }

                // Dormo per 5 secondi, poi ricomincio il giro
                Thread.sleep(5000);
            } catch (InterruptedException ex) {
//                Logger.getLogger(Gioco.class.getName()).log(Level.SEVERE, null, ex);
                outer.dest.scriviDBG(ex.toString());
            }
        }
    }
    BabaIO dove;

    public Tempo(BabaIO d, Gioco outer) {
        super();
        this.outer = outer;
        dove = d;
    }
}
